#define __TIMER_H

#include <stdlib.h>
#include <stdio.h>
#include "typedef.h"
#include "common.h"
#include "BufCir.h"
#include "rout.h"
#include "main.h"
#include "uart.h"
#include <timer.h>



////////////////////////////////////////////////////////////////////////////////////////////////
//	LED
const u08 letPatternTable[12][32] = {
	{0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1}
};
////////////////////////////////////////////////////////////////////////////////////////////////

u08 sys,dia,pul;

//===========================================================================================================
void RunLedBlinkModeInit(void)
//===========================================================================================================
{
	runLed.mode = 255;
	LED_RUN_OFF;
}
//===========================================================================================================
void RunLedBlinkMode(u08 bMode)
//===========================================================================================================
{
	if (runLed.mode != bMode)
	{
		runLed.mode = bMode;		// eseguo la funzione solo se richiesto diverso tipo di lampeggio
		runLed.idx =0;				// SYNC su nuova chiamata  rel 3.5  "061216"
		LED_RUN_OFF;
		runLed.ptr = (const u08 *)&letPatternTable[bMode-1][0];
	}
}



//=====================================================================================
s16 NoTout(u16 msCtr,u16 orgTime,u16 tout)
//=====================================================================================
{
u16 tmp;
	tmp = msCtr - orgTime;
	return(tmp < tout);
}

//=====================================================================================
s16 YesTout(u16 msCtr,u16 orgTime,u16 tout)
//=====================================================================================
{
u16 tmp;
	tmp = msCtr - orgTime;
	return(tmp >= tout);
}

int ctr2mS5 =0;
int ctr10mS =0;
int ctr100mS =0;

u08 toggle;
char nMsg[100];

enum
{
	SPR_IDLE_SM,
	SPR_SECOND_BLOCK_SM
};

//================================================================================================
void PressureNotificationHandleInit(void)
//================================================================================================
{
	MemClear(U08PTR sendPr, sizeof(sendPr));
	sendPr.notifyTmrReq =0;
    notifyEnabled =0;
}

//================================================================================================
void PressureNotificationHandleStart(u08 immediate)
//================================================================================================
{
    sendPr.delay_10mS = NOTIFICATION_DELAY_100MS;
	if (immediate)
	{
    	sendPr.notifyTmrReq =1; // per avere prima risposta subito pronta verso Client
	}
    notifyEnabled =1;
}
//================================================================================================
void SendPressureNotificationHandle(void)
//	--> qui ogni 100mS
//================================================================================================
{
    if (sendPr.delay_10mS)
	{
    	if (!--sendPr.delay_10mS)
		{
    		sendPr.delay_10mS = NOTIFICATION_DELAY_100MS;
			sendPr.notifyTmrReq =1;
		}
	}
}

//================================================================================================
static void HandleLed(void)
//================================================================================================
{
	if (++toggle &1)
	{
		if (bleActive)
		{
    		if (runLed.ptr[runLed.idx])		LED_RUN_ON;
    		else							LED_RUN_OFF;
		}
		else
		{
    		if (!runLed.ptr[runLed.idx])	LED_RUN_ON;
    		else							LED_RUN_OFF;
		}
    	runLed.idx = ((++runLed.idx) & 15);
	}
}
/*
void Timer1_ClearInterrupt(uint32 interruptMask)
{
    Timer1_INTERRUPT_REQ_REG = interruptMask;
}
*/
//================================================================================================
CY_ISR(Timer2mS5)
//================================================================================================
{
    //  --> qui ogni 2,5mS

    Timer1_ClearInterrupt(Timer1__INTR_MASK_CC_MATCH);

    if (comm.delaySend_2mS5)         	--comm.delaySend_2mS5;

	if (comm.toutWaitLF_2mS5)
	{
		if (!--comm.toutWaitLF_2mS5)
		{
			comm.toutRxLF =1;
		}
	}
	if (++ctr2mS5 >= 4)
	{
		// 10mS
		//
		ctr2mS5 =0;

		millisecCtr += 10;

    	SendPressureNotificationHandle();

    	if (++ctr10mS >= 10)
        {
		    // 100mS
		    //
    		ctr10mS =0;

/*
			if (uart2.toutClr_to_Start_100mS)
            {
                if (!--uart2.toutClr_to_Start_100mS)
                {
                    DebugPrint("!TOUT PreStart\n");
                    UartErroreMisura();
                }
            }

			if (uart2.toutShowDiastolic_100mS)   --uart2.toutShowDiastolic_100mS;

			if (uart2.toutFineMisura_100mS)
            {
                if (!--uart2.toutFineMisura_100mS)
                {
                    DebugPrint("!TOUT MISURA\n");
                    UartErroreMisura();
                }
            }
*/
			HandleLed();
	//LED_RUN_CPL;

			//-----------------------------------------------------------------
            if (debugTout_100mS)
            {
                if (!--debugTout_100mS)
                {
                    PressureNotificationHandleInit();   // STOP Notify
                    goodPwd =0;
                }
            }
            if (sendPr.debugNotify)
            {
                if (sendPr.delay_10mS) // notifica Attiva?
                {
                	++ctr100mS;
                	if (ctr100mS == 10)
                    {
                    }
                	if (ctr100mS == 40)
                    {
                        ctr100mS =0;

                    }
            	}
                else
                {
                    ctr100mS =0;
                }
            }
			//-----------------------------------------------------------------
        }
	}
}
/* [] END OF FILE */
