/*******************************************************************************
* File Name: TimerIrq.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_TimerIrq_H)
#define CY_ISR_TimerIrq_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void TimerIrq_Start(void);
void TimerIrq_StartEx(cyisraddress address);
void TimerIrq_Stop(void);

CY_ISR_PROTO(TimerIrq_Interrupt);

void TimerIrq_SetVector(cyisraddress address);
cyisraddress TimerIrq_GetVector(void);

void TimerIrq_SetPriority(uint8 priority);
uint8 TimerIrq_GetPriority(void);

void TimerIrq_Enable(void);
uint8 TimerIrq_GetState(void);
void TimerIrq_Disable(void);

void TimerIrq_SetPending(void);
void TimerIrq_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the TimerIrq ISR. */
#define TimerIrq_INTC_VECTOR            ((reg32 *) TimerIrq__INTC_VECT)

/* Address of the TimerIrq ISR priority. */
#define TimerIrq_INTC_PRIOR             ((reg32 *) TimerIrq__INTC_PRIOR_REG)

/* Priority of the TimerIrq interrupt. */
#define TimerIrq_INTC_PRIOR_NUMBER      TimerIrq__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable TimerIrq interrupt. */
#define TimerIrq_INTC_SET_EN            ((reg32 *) TimerIrq__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the TimerIrq interrupt. */
#define TimerIrq_INTC_CLR_EN            ((reg32 *) TimerIrq__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the TimerIrq interrupt state to pending. */
#define TimerIrq_INTC_SET_PD            ((reg32 *) TimerIrq__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the TimerIrq interrupt. */
#define TimerIrq_INTC_CLR_PD            ((reg32 *) TimerIrq__INTC_CLR_PD_REG)



#endif /* CY_ISR_TimerIrq_H */


/* [] END OF FILE */
