/*******************************************************************************
* File Name: common.h
*
* Version 1.0
*
* Description:
*  Contains the function prototypes and constants available to the example
*  project.
*
********************************************************************************
* Copyright 2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#include <project.h>


/***************************************
*        API Constants
***************************************/

/* LED states */
#define LED_ON                              (0u)
#define LED_OFF                             (1u)

#define DISCONNECTED                        (0u)
#define ADVERTISING                         (1u)
#define CONNECTED                           (2u)
#define CONNECTED_SERVER_DISCOVERED         (3u)

/* Delay value to produce blinking LED */
#define BLINK_DELAY                         (250u)

/* Constants for buttonState */
#define BUTTON_IS_PRESSED                   (1u)
#define BUTTON_IS_NOT_PRESSED               (0u)


/***************************************
*        Function Prototypes
***************************************/

void HandleLeds(void);
uint8 ButtonPressed(void);
void MakeWordFromBytePtr(uint8 bytePtr[], uint16 *wordPtr);
void GenericAppEventHandler(uint32 event, void * eventParam);

CY_ISR_PROTO(ButtonPressInt);


/***************************************
*        External data references
***************************************/
extern uint8                state;
extern uint16               advBlinkDelayCount;
extern uint8                advLedState;
extern uint8                buttonState;
extern uint16               supportedCategories;


#define RXBUF_LEN 		(2+sizeof(struct _itemSetup)+4+8)  // devo accettare comando Max lunghezza:  "WC...........CRC4"+8
#define TXBUF_LEN 		(2+sizeof(struct _itemSetup)+4+8)  // WC...........CRC4+8

//#define BLE_GATT_READ_HANDLE   	0x12
#define BLE_GATT_NOTIFY_HANDLE  0x12
#define BLE_GATT_WRITE_HANDLE   0x16


/* [] END OF FILE */
