/*
                                                                          	
  				             R O U T . C                                 	
  																			
        Funzioni di impiego generale         Last Update:15/09/2005		
  																			
  */

#define	__ROUT_H

#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "typedef.h"
#include "common.h"
#include "rout.h"

struct _nibble4 {
	u08 n1 :4;
	u08 n2 :4;
	//
	u08 n3 :4;
	u08 n4 :4;
};

struct _nibble8 {
	u08 n1 :4;
	u08 n2 :4;
	//
	u08 n3 :4;
	u08 n4 :4;
	//
	u08 n5 :4;
	u08 n6 :4;
	//
	u08 n7 :4;
	u08 n8 :4;
};

/*ͻ
       Sum8()	Restituisce il SUM8 di n bytes				           	  	
  		Input:	p = ptr bytes                                               
  				n = num. bytes                                              
  		return: SUM8 di n. u08                                             
                                                                           
    Il Sum8  calcolato addizionando, senza riporto, i bytes della stringa 
    + la lunghezza della stringa stessa. 									
    N.B. Attenzione al modello di memoria utilizzato !!!!                  
  ͼ*/
u08 Sum8(u08 *p, u08 n)
{
u08 sum =n;

	while (n--)	sum += (*p++);
	//
	return (sum);
}

/*ͻ
       Sum16()	Restituisce il SUM16 di n bytes				           	   	 
  		Input:	p = ptr bytes                                                
  				n = num. bytes                                               
  		return: SUM16 di n. u08                                             
                                                                            
    Il Sum16  calcolato addizionando, senza riporto, i bytes della stringa 
    + CRC_BASE_OFFSET. 				  									 
    N.B. Attenzione al modello di memoria utilizzato !!!!                   
  ͼ*/
u16 Sum16(u08 *p, int n)
{
u16 sum =CRC_BASE_OFFSET;

	while (n--)	sum += *p++;
	return (sum);
}

//================================================================================================================
u08 Nibble2Ascii(u08  n)
//================================================================================================================
{
	if (n <= 9)
		return '0' + n;
	else
		return 'A' + n-10;
}

//================================================================================================================
u08 Ascii2Nibble(u08  a)
//================================================================================================================
{
	if (a <= '9')
		return a - '0';
	else
		return a - 'A' +10;
}

// by m.g. 05/03/2004 
void Ui2Asc(u16 n, u08 *p) {
//
//	Input: n Unsigned int.
//		   p ptr a buffer deposito caratteri Ascii
//	Trasforma un u16 (Unsigned int) in 5 caratteri ascii terminati con '0'
//	Toglie gli zeri iniziali. (In questa versione il leding 0  condizionato dal parametro da visualizzare)
//	Necessita di un buffer di appoggio lungo almeno 5+1 u08
//

u08 leading=1;			  // attivo leading zero (versione standard)
u08 r,i;
u16 sub=10000;				  //decine di migliaia
	for (i=5;i;i--) {
		if (i==1) leading=0;	  // disattivo leading sulle unit
		r=0;
		while (n >= sub) {
			n-= sub;
			++r;
		}
		if (r || (!leading)) {
			r+='0';
			leading=0;
		}
		else {
			r=' ';
		}
		*p=r;
		sub=sub/10;
		p++;
	}
	*p = 0;				  // Terminatore Stringa Ascii
}

// by a.t. 25/11/2009 
void Bin2Ascii(dword n, u08 *p, u08 len, u08 zeroLead)
//
//	Input: 	n :16bit.
//		   	p :ptr a buffer deposito caratteri Ascii
//			zeroLead == TRUE :imposta gli zeri iniziali(0x30) altrimenti lascia blank(0x20).
//	Trasforma un dword (32bit) in n caratteri ascii (max 10) terminati con 0x00
//
{
u08 r,i,l,wrAscii;
dword sub =1;

	l = (len-1);
	while (l--)		sub *=10;
	//
	wrAscii =FALSE;
	for (i =len; i; i--)
	{
		if (i == 1) zeroLead =TRUE;
		r =0;
		while (n >= sub)
		{
			n -=sub;
			++r;
			wrAscii =TRUE;
		}
		if ((zeroLead == TRUE) || (wrAscii ==TRUE))	r+='0';
		else									   	r =' ';
		//
		*p++ =r;
		sub /=10;
	}
	*p =0;				  // Terminatore Stringa Ascii
}

// by a.t. 01/08/2010 
void BinDwordToAscii(dword n, u08 *p)
//
//	Input: 	n :32bit.
//		   	p :ptr a buffer deposito caratteri Ascii
//	Trasforma un dword (32bit) in n caratteri ascii (max 8) terminati con 0x00
//
{
struct _nibble8 *pN;
	//
	pN =(struct _nibble8 *)&n;
	//
	if (pN->n8 > 9)		*p++ = pN->n8 + 0x37;
	else 				*p++ = pN->n8 + 0x30;
	if (pN->n7 > 9)		*p++ = pN->n7 + 0x37;
	else 				*p++ = pN->n7 + 0x30;
	if (pN->n6 > 9)		*p++ = pN->n6 + 0x37;
	else 				*p++ = pN->n6 + 0x30;
	if (pN->n5 > 9)		*p++ = pN->n5 + 0x37;
	else 				*p++ = pN->n5 + 0x30;
	if (pN->n4 > 9)		*p++ = pN->n4 + 0x37;
	else 				*p++ = pN->n4 + 0x30;
	if (pN->n3 > 9)		*p++ = pN->n3 + 0x37;
	else 				*p++ = pN->n3 + 0x30;
	if (pN->n2 > 9)		*p++ = pN->n2 + 0x37;
	else 				*p++ = pN->n2 + 0x30;
	if (pN->n1 > 9)		*p++ = pN->n1 + 0x37;
	else 				*p++ = pN->n1 + 0x30;
}

// by a.t. 01/08/2010 
void BinWordToAscii(u16 n, u08 *p)
//
//	Input: 	n :16bit.
//		   	p :ptr a buffer deposito caratteri Ascii
//	Trasforma un dword (32bit) in n caratteri ascii (max 8) terminati con 0x00
//
{
struct _nibble4 *pN;
	//
	pN =(struct _nibble4 *)&n;
	//
	if (pN->n4 > 9)		*p++ = pN->n4 + 0x37;
	else 				*p++ = pN->n4 + 0x30;
	if (pN->n3 > 9)		*p++ = pN->n3 + 0x37;
	else 				*p++ = pN->n3 + 0x30;
	if (pN->n2 > 9)		*p++ = pN->n2 + 0x37;
	else 				*p++ = pN->n2 + 0x30;
	if (pN->n1 > 9)		*p++ = pN->n1 + 0x37;
	else 				*p++ = pN->n1 + 0x30;
}

//========================================================================================
//
//      Crc16()	Restituisce il CRC16 di n bytes
//		Input:	msg = ptr bytes
//				len = num. bytes
//              org = offset di avvio calcolo
//
//		return: CRC16
//
//  Il tipo di Crc16  definito qu sotto tramite macro
//  N.B. A seconda del micro attenzione al modello di memoria utilizzato !!
//
#define CRC_CCITT	0x0810
#define CRC_16		0x4002
//
#define CRC_TYPE	CRC_CCITT
//========================================================================================
u16 Crc16(u08 *msg, u16 len, u16 orgVal)
//========================================================================================
{
u08 i,tmp;
u16 crc =orgVal;	   // Crc di partenza
u16 n;

	for (n=0; n<len; n++,msg++)
	{
		tmp = *msg;
		for (i=0; i<8; i++)
		{
			if ((crc^tmp)&1)
			{
				crc^=CRC_TYPE;
				crc>>=1;
				crc|=0x8000;
			}
			else
			{
				crc>>=1;
			}
			tmp>>=1;
	   	}
	}
	return crc;
}

//========================================================================================
u16 Crc16Ble(u08 *p, u16 len, u16 ofst)
//  Crc16  usato x applicazioni SHD su BLE 4.0
//========================================================================================
{
	u08 x;
	u16 crc = ofst;

	while (len--)
    {
		x = crc >> 8 ^ *p++;
		x ^= x >>4;
		crc = (crc << 8) ^ ((u16)(x << 12)) ^ ((u16)(x <<5)) ^ ((u16)x);
	}
	return crc;
}

// ============================================================================ //
//              FUNZIONE :      StrCopy()                                       //
//     Copia di una stringa                                                     //
// ============================================================================ //
void StrCopy(u08 *ptrDst, u08 *ptrSrc)
{
    while (*ptrSrc != 0)
    {
        *ptrDst++ = *ptrSrc++;
    }
    *ptrDst = 0;
}

// ============================================================================ //
//              FUNZIONE :      StrAppend()                                     //
//     Concatenamento di stringhe                                               //
// ============================================================================ //
void StrAppend(u08 *strDst, u08 *strSrc)
{
u08 len;
	len = StrLen(strDst);
	StrCopy(strDst+len, strSrc);
}

// ============================================================================ //
//              FUNZIONE :      CharAppend()                                    //
//     Concatenamento di stringhe                                               //
// ============================================================================ //
void CharAppend(u08 *strDst, u08 ch)
{
u08 len;
	len = StrLen(strDst);
	strDst[len] = ch;
}


// ============================================================================ //
//              FUNZIONE :      StrLen()                                        //
//    Calcolo lunghezza stringa                                                 //
// ============================================================================ //
u16 StrLen(u08 *ptrStr)
{
    u16 lenStr =0;

    while (*ptrStr++ != 0)
    {
        lenStr++;
    }
    return lenStr;
}

//============================================================================
u08 MemSeekChr(u08 *ptrSrc, u08 chr, u08 *idx, u08 lenMax)
//============================================================================
{
u08 i;
    for (i = 0; lenMax; lenMax--, ptrSrc++, i++)
    {
        if (*ptrSrc == chr)
        {
			*idx = i;
			return 0;
        }
    }
	return 1;
}

//============================================================================
u08 MemSeekChrNumeric(u08 *ptrSrc, u08 *idx, u08 lenMax)
//============================================================================
{
u08 i;

    for (i = 0; lenMax; lenMax--, ptrSrc++, i++)
    {
        if ((*ptrSrc >= '0') && (*ptrSrc <= '9'))
        {
			*idx = i;
			return 0;
        }
    }
	return 1;
}

//============================================================================
u08 MemRamCompare(u08 *ptrDst, u08 *ptrSrc, u16 lenCompare)
//============================================================================
{
    for (; lenCompare; lenCompare--)
    {
        if (*ptrDst++ != *ptrSrc++)
        {
			return 1;
        }
    }
	return 0;
}

//============================================================================
void MemFill(u08 *ptrDst, u08 valFill, u16 lenFill)
//============================================================================
{
    u16 i;
    for (i=0; i < lenFill; i++)
    {
        *ptrDst++ = valFill;
    }
}

//============================================================================
void MemClear(u08 *ptrDst, u16 lenFill)
//============================================================================
{
    u16 i;

	if (lenFill)
    for (i=0; i < lenFill; i++)
    {
        *ptrDst++ = 0;
    }
}

//============================================================================
void MemCopy(u08 *ptrDst, u08 *ptrSrc, u16 lenCopy)
//============================================================================
{
    u16 i;

    for (i=0; i < lenCopy; i++)
    {
        *ptrDst++ = *ptrSrc++;
    }
}

//============================================================================
void MemCopyRom2Ram(u08 *ptrDst, const unsigned char *ptrSrc, u16 lenCopy)
//============================================================================
{
u16 i;

    for (i=0; i < lenCopy; i++)
    {
        *ptrDst++ = *ptrSrc++;
    }
}

//============================================================================
u08 StringCopyBeforeEndChar(u08 *ptrDst, u08 *ptrSrc, u08 endChar, u08 lenMax)
//============================================================================
{
	for (; lenMax; lenMax--)
	{
		if (*ptrSrc == endChar)
		{
			*ptrDst = 0;				// end of string
			return 0;
		}
		*ptrDst++ = *ptrSrc++;
	}
	*--ptrDst = 0;                      // comunque: end of string
	return 1;
}


//================================================================================================================
void Bin2AscStrNchar(u08 *pd, u08 value, u08 nChar)
//================================================================================================================
{
u08 tmp;

	if (nChar >2)
	{
		*pd =0;
		while (value >= 100)
		{
			++*pd;
			value-=100;
		}
		tmp = *pd;
		*pd++ = '0' + tmp;
	}
	if (nChar >1)
	{
		*pd =0;
		while (value >= 10)
		{
			++*pd;
			value-=10;
		}
		tmp = *pd;
		*pd++ = '0' + tmp;
	}
//	*pd++ = '0' + tmp;
	*pd = '0' + value;
}

//================================================================================================================
void Bin2AscStr(u08 *pd, u08 value)
//================================================================================================================
{

	if (value >99)
	{
		*pd=0;
		while (value >= 100) 	{++*pd; value-=100;}
		*pd = '0' + *pd;

		*++pd=0;
		while (value >= 10)		{++*pd; value-=10;}
		*pd = '0' + *pd;

		*++pd = '0' + value;
	}
	else if (value >9)
	{
		*pd=0;
		while (value >= 10)		{++*pd; value-=10;}
		*pd = '0' + *pd;

		*++pd = '0' + value;
	}
	else
	{
		*pd = '0' + value;
	}
	*++pd = 0;
}

//================================================================================================================
u32 Asc2Bin(u08 *ps)
//================================================================================================================
{
u32 tmp =0;
u32 val =1;
u08 i =0;

	for (; *ps != 0x00; ps++)
		i++;
	//
	ps--;
	for (; i; i--)
	{
		tmp += (u32)(*ps-- - '0') * val;
		val *=10;
	}
	return (tmp);
}
/*
//================================================================================================================
u16 AscLen2Bin(u08 *ps, u08 len)
//================================================================================================================
{
u16 tmp;
u08 val =1;

	for (tmp =0; tmp < len; ps++, tmp++) ;
	//
	ps--;
	for (tmp =0; len; len--)
	{
		tmp += (u16)(*ps-- - '0') * val;
		val *=10;
	}
	return tmp;
}*/

//================================================================================================================
u32 A2B(u08 *ps, u08 len)
//================================================================================================================
{
u16 tmp;
u32 res,molt;

	for (res =0; len; len--)
	{
		if ((*ps >= '0') && (*ps <= '9'))
		{
			for (molt =1, tmp =(len-1); tmp; tmp--)		molt *=10;
			//
			res +=((u32)(*ps - '0') * molt);
		}
		ps++;
	}
	return (res);
}


//================================================================================================================
void Bin2Bcd(u08 *pd, u08 value, u08 nChar)
//================================================================================================================
{
	pd[0] = pd[1] = 0;

	if (nChar > 2)
	{
		while (value >= 100) 	{++*pd; value-=100;}
		++pd;
	}
	if (nChar > 1)
	{
		while (value >= 10)		{++*pd; value-=10;}
		++pd;
	}
	*pd = value;
}
//================================================================================================================
u16 Bcd2Bin(u08 *ps, u08 nChar)
//================================================================================================================
{
u16 tmp = 0;
	if (nChar == 3)
	{
		tmp  = (u16)*ps++ *100;
	}
	tmp += (u16)*ps++  *10;
	tmp += (u16)*ps;
	return tmp;
}
//================================================================================================================
u08 KeyBcd2Asc(u08 cifra)
//================================================================================================================
{
	if (cifra <= 9)	return cifra + '0';
	else			return cifra + ('A'-10);
}
//================================================================================================================
u08 KeyAsc2Bcd(u08 key)
//================================================================================================================
{
	if (key <= '9')	return key - '0';
	else			return key - ('A'-10);
}


//================================================================================================================
u08 AsciiNumber(u08 dato)
//================================================================================================================
{
	if ((dato >= '0') && (dato <= '9'))		return TRUE;
	return FALSE;
}

//================================================================================================================
u08 AsciiChar(u08 dato)
//================================================================================================================
{
	if ( ((dato >= 'A') && (dato <= 'Z')) || ((dato >= 'a') && (dato <= 'z')) )		return TRUE;
	//
	return FALSE;
}

//================================================================================================================
// Controllo che il nome della dir
u08 CheckDirName(u08 *pDirName)
//================================================================================================================
{
u08 idx;
u08 dirNameCtr =0;

	for (idx =0; idx < DIR_BUFF_LEN; idx++)
	{
		if (!pDirName[idx])	 	break;	// trovato fine stringa
		//
		if (AsciiChar(pDirName[idx])) 	dirNameCtr++;
		else							dirNameCtr =0;
	}
	//
	if (dirNameCtr == DIR_NAME_LEN)		return (1);
	//
	return (0);
}

//================================================================================================================
u08 HexAscii(u08 x)
//================================================================================================================
{
	if (x <= 9)
		return '0' + x;
	else
		return 'A' + x-10;
}


// by B.L.  Buona per tempo di esecuzione! 
//	Rispetto a by M.G. ha piu' codice ma un tempo di esecuzione inferiore
u08 ShiftRight(u08 *p,u08 len,u08 v)
//
//	Shifts Right "p" buffer, where:  p -> LSByte of buffer
//	Bit 0 of the lowest u08 in RAM is treated as the LSBit
//	Bit 7 of the highest u08 in RAM is treated as the MSBit
//
//
{
u08 carry;
	carry = *p & 1;
	do
	{
		*p >>=1;
		if (*(p+1) &1)
		*p |= 0x80;
		++p;
	} while (--len >1);
	*p >>=1;
	if (v)
		*p |= 0x80;
	return (carry);
}

//=============================================================================================================================
u08 AbsByteValue(u08 val1, u08 val2)
//=============================================================================================================================
{
	if (val1 >= val2)	return (val1-val2);
	//
	return (val2-val1);
}

//=============================================================================================================================
u16 AbsWordValue(u16 val1, u16 val2)
//=============================================================================================================================
{
	if (val1 >= val2)	return (val1-val2);
	//
	return (val2-val1);
}

//=============================================================================================================================
dword AbsDwordValue(dword val1, dword val2)
//=============================================================================================================================
{
	if (val1 >= val2)	return (val1-val2);
	//
	return (val2-val1);
}

// Funzioni per creare un trace firmware
//=======================================================================================================================
void ClearTrace(void)
//=======================================================================================================================
{
	MemClear((u08 *)&trace, sizeof(trace));
	traceIdx =0;
}

//=======================================================================================================================
void PutTrace(u08 dato)
//=======================================================================================================================
{
	trace[traceIdx] = dato;
	//
	if (++traceIdx >= LEN_TRACE_BUFF)	traceIdx =0;
}
/*
//=======================================================================================================================
void SaveCrc16InRamUinit(u08 *pRam, u16 len)
//=======================================================================================================================
{
	eepProdCrc16 = Crc16(pRam, len-2);
}

//=======================================================================================================================
// Ritorno esito operazione: 0 = OK; 1= Err(Crc don't matching)
u08 CheckCrc16InRamUinit(u08 *pRam, u16 len)
//=======================================================================================================================
{
	if (eepProdCrc16 == Crc16(pRam, len-2))
	{ 	// CRC 16 Letto = a calcolato
		return 0;
	}
	return 1;
}*/

//=======================================================================================================================
void ValueAscendingOrder(u08 *pArray, u08 len)
//=======================================================================================================================
{
u08 idx,idx2,idxMin,valMin;

	for (idxMin =0, idx =0; idx < len; idx++)
	{
 		for (valMin =0xFF, idx2 =idx; idx2 < len; idx2++)
		{
			if (pArray[idx2] < valMin)
			{
				valMin = pArray[idx2];
				idxMin = idx2;
			}
		}
		pArray[idxMin] = pArray[idx];
		pArray[idx]    = valMin;
	}
}

//=======================================================================================================================
// Aggiunsta approsimazioni sul float vedi il caso di (2.35*100) =234
u32 GetIntToFloat(float val)
//=======================================================================================================================
{
u32 res =(u32)val;
float fTmp;

	fTmp =(float)res;
	fTmp =(fTmp - val);
	//
	if (fTmp < -0.5f)		return (++res);
	else if (fTmp > 0.5f)	return (--res);
	//
	return (res);
}

//=======================================================================================================================
void EuroBinToAscii(u32 priceBin, u08 *pPriceAscii)
//=======================================================================================================================
{
u32 priceTmp;

	priceTmp =(priceBin/100);
	// Euro
	if (priceTmp == 0)
	{
		pPriceAscii[0] =' ';
		pPriceAscii[1] =' ';
		pPriceAscii[2] ='0';
	}
	else
	{
		if (priceTmp > 999)		priceTmp =999;
		//
		Bin2Ascii(priceTmp, (u08 *)&pPriceAscii[0], 3, TRUE);
	}
	pPriceAscii[3] =',';
	//
	// Cent
	priceTmp =(priceBin-(priceTmp*100));	// scorporo euro da centesimi
	if (priceTmp > 99)	priceTmp =99;
	//
	Bin2Ascii(priceTmp, (u08 *)&pPriceAscii[4], 2, TRUE);
	pPriceAscii[6] =0;   	// Null terminate
}
/* ============================================================================ */
/** @name   IntervalloUint8
 *  @brief  Routine used to detect the nearest position of a value in a pointer
 *  @param  *ITAB pointer to the array
 *  @param  X value
 *  @retval rtrnPnt pointer to the nearest value                              */
/* ============================================================================ */
u08 IntervalloUint8(u16 X, u08 *ITAB, u08 tabSize)
{
u08 i;

   /* Loop used to check the table */
    for (i=0; i < tabSize; i++)
        if (X<= *(ITAB+i)) return ((u08)(i));

    return ((u08)(tabSize));
}

/* ============================================================================ */
/** @name   Intervallo
 *  @brief  Routine used to detect the nearest position of a value in a pointer
 *  @param  *ITAB pointer to the array
 *  @param  X value
 *  @retval rtrnPnt pointer to the nearest value                              */
/* ============================================================================ */
u08 Intervallo(s16 X, const s16 *ITAB, u08 tabSize)
{
u08 i;

   /* Loop used to check the table */
    for (i=0; i < tabSize; i++)
	{
        if (X <= *(ITAB+i)) 	return ((u08)(i));
	}
	/**/
    return ((u08)(tabSize));
}


/* ============================================================================ */
/** @name   Curva
 *  @brief  Routine used to execute an interpolation between two arrays
 *  @param  *X_ITAB pointer to the first array
 *  @param  *Y_ITAB pointer to the second array
 *  @param  X value
 *  @retval val returned converted value                                        */
/* ============================================================================ */
s16 Curva(s16 X, s16 *X_ITAB, s16 *Y_ITAB, u08 tabSize)
{
u08 J1,J2;
s16 val,x1,x2,y1,y2;
u32 supL;

   	J2=Intervallo(X, X_ITAB, tabSize);
   	J1=(u08)(J2-(u08)1);

   	x1=*(X_ITAB+J1);
   	x2=*(X_ITAB+J2);

   	y1=*(Y_ITAB+J1);
   	y2=*(Y_ITAB+J2);

   	if (J2 == 0)
   	{
   	   val = y2;      // valore minore del primo punto
   	}
   	else if (J2 == tabSize)
   	{
   	   val = y1;      // valore maggiore dell'ultimo punto
   	}
   	else
   	{
   	   if (X < x1)
   	   {
   	      val = y1;
   	   }
   	   else
   	   {
   	      supL  = y2-y1;
   	      supL *= (X-x1);
   	      val   = (s16)((supL / (x2-x1)) + y1);
   	   }
   	}
	//
   	return (val);
}



//
void PutWeight(u08 *pd, s32 weightGr, u08 nChars)
//
{
u08 tmp[20];

	memset(tmp, 0x20, sizeof(tmp));	    // blank
	if (nChars == 6)
	{
		sprintf((char *)&tmp[0],"%+6.6ld", (signed long)weightGr);  //
		//
		//	Risoluzione: 10 grammi
		//
		//	cambio formato: "cdu.dcm" (centinaia,decine,unita'.decimi,centesimi,millesimi) es:  123.057
		//
		tmp[7] = tmp[6];
		tmp[6] = tmp[5];
		tmp[5] = tmp[4];
		tmp[4] = '.';
		// leading zeroes off:
		if (tmp[1] == '0')
		{
			tmp[1] =' ';
			if (tmp[2] == '0')
			{
				tmp[2] =' ';
			}
		}
		tmp[8] = 0;                     // End Of String
		memcpy(pd,&tmp[0],1+3+1+3+1);	// +153.245 +eos
	}
	else
	{
		// 5
		sprintf((char *)&tmp[3],"%+6.6ld",(signed long)weightGr);  //
		tmp[2] = tmp[3];
		tmp[3] = tmp[4];
		tmp[4] = tmp[5];
		tmp[5] = tmp[6];
		tmp[6] = '.';
		// leading zeroes off:
		if (tmp[3] == '0')
		{
			tmp[3] =' ';
			if (tmp[4] == '0')
			{
				tmp[4] =' ';
			}
		}
		memcpy(++pd,&tmp[2],1+3+1+2+1);	// +153.24 +eos
		tmp[7] = 0;                     // End Of String
	}
}
//
signed long abs_GG(signed long w)
//
{
	if (w < 0)		return (w * -1);
	else			return (w);
}

//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
void BinToAsciiFloat(u32 bin, u08 *pStr)
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
{
u16 tmp =0;

	if (bin > 65535)		bin =65535;  // = 655.35 (max)
	//
	if (bin < 100)
	{
//		pStr[0] =' ';
		pStr[0] =' ';
		pStr[1] ='0';
	}
	else
	{
		tmp =(bin/100);
		Bin2Ascii(tmp, (u08 *)&pStr[0], 2, FALSE);
	}
	// Decimali
	pStr[2] =',';
	bin =(bin-(tmp*100));
	Bin2Ascii(bin, (u08 *)&pStr[3], 2, TRUE);
}

//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
u08 AsciiFloatToBin(u08 *pAsciiF, u32 *pVal)
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
{
u08 len,i;
u32 res;

	len =StrLen(pAsciiF);
	//
	for (i =0; i < len; i++)
	{
		if ((*(pAsciiF+i) == ',') || (*(pAsciiF+i) == '.')) 	break;
	}
	//
	if (i == len)
	{
		// Errore non trovato , o . decimali...
		return 1;
	}
	//
	res  =A2B((u08 *)pAsciiF, i);
	res *=100;
	pAsciiF +=i+1;                      // mi porto dopo la virgola
	res +=A2B((u08 *)pAsciiF, 2);
	//
	*pVal =res;
	//
	return 0;
}

//=======================================================================================================================
void AsciiStr2BinArray(u08 *bin, u08 *asc, u16 binLen)
//=======================================================================================================================
{
    for (;binLen; binLen--)
    {
        u08 tmp;
        tmp = (Ascii2Nibble(*asc++)) <<4;
        tmp |= Ascii2Nibble(*asc++);
        *bin++ = tmp;
    }
}
//=======================================================================================================================
void StrCatLen(char *d, char *s, u16 sLen)
//	"sLen" : *s  Len Max
//=======================================================================================================================
{
	// cerco fine stringa su destinazione...
	while (*d)
	{
		++d;
	}
	// accodo stringa in ingresso
	while (*s && sLen--)
	{
		*d++ = *s++;
	}
}
#ifdef FUNZ_UTILIZZATE
//=======================================================================================================================
// Gestione TurnoMatic:
// 1) Acquisizione valore di priorit tramite: "TurnoMaticGetNum()"
// 2) Controllo valore acquisito con attuale (TurnoMaticChkBusy(...)) se = procedo ad esecuzione, in caso contrario
//    attendo fine esecuzione da altro task
// 3) A fine esecuzione funzione conume chiamare: "TurnoMaticIncNum()" in modo proseguire gestione con
//    il successivo prenotato
//=======================================================================================================================
//=======================================================================================================================
u08 TurnoMaticGetNum(struct _turnoMatic *pTm)
//=======================================================================================================================
{
	return (pTm->getN++);
}

//=======================================================================================================================
// Input: *pTm: Puntatore alla struct tm in gestione
//		   num: Numero prelevato in precedenza da controllare
//	wait_100mS:	se =0 : Nessuna attesa (vedi caso macchina a stati)
//				se != 0 : attesa in 100mS prima di ritornare 1
//
// Output: 0 = Ok si pu proseguire con operazione
//		   1 = Busy
extern void WatchDogRetrigger(u08 bypass);
//=======================================================================================================================
u08 TurnoMaticCheck(struct _turnoMatic *pTm, u08 num, u16 wait_100mS)
//=======================================================================================================================
{
	LD_TIM_100MS(pTm->tout);
	while (num != pTm->putN)
	{
		if ((!wait_100mS) || YES_T0_TIM_100MS(pTm->tout, wait_100mS))
		{
			return 1;
		}
		//
		WatchDogRetrigger(1);
	}
 	return 0;
}

//=======================================================================================================================
void TurnoMaticIncNum(struct _turnoMatic *pTm)
//=======================================================================================================================
{
	pTm->putN++;
}
#endif
