/*
                                                                          	
  				             R O U T . H                                 	
                                                                          	
        Dichiarazioni per Funzioni di impiego generale Date:04/12/05		
                                                                          	
  */

#ifdef	__ROUT_H
	#define	rout_ext
#else
	#define	rout_ext	extern
#endif

#include "typedef.h"

#define	CRC_BASE_OFFSET		0x9A54

#define LEN_TRACE_BUFF		100

#define DIR_BUFF_LEN		13
#define DIR_NAME_LEN		3
// Turnomatic wait or not if busy
enum {
	TM_NOT_WAIT,
	TM_WAIT
};


struct _turnoMatic
{
	u08 putN;
	u08 getN;
	u16 tout;
};

rout_ext u08 Sum8(u08 *p, u08 n);
rout_ext u16 Sum16(u08 *ps,int len);
rout_ext u16 Crc16(u08 *msg,u16 len, u16 orgVal);
rout_ext void MemFill(u08 *ptrDst, u08 valFill, u16 lenFill);
rout_ext void MemCopy(u08 *ptrDst, u08 *ptrSrc, u16 lenCopy);
rout_ext void MemCopyRom2Ram(u08 *ptrDst, const unsigned char *ptrSrc, u16 lenCopy);
rout_ext void MemClear(u08 *ptrDst, u16 lenFill);
rout_ext u08 MemRamCompare(u08 *ptrDst, u08 *ptrSrc, u16 lenCompare);
rout_ext u08 MemSeekChrNumeric(u08 *ptrSrc, u08 *idx, u08 lenMax);
rout_ext void Bin2AscStr(u08 *pd, u08 value);
rout_ext u32  Asc2Bin(u08 *ps);
//rout_ext u16 AscLen2Bin(u08 *ps, u08 len);
rout_ext u08 KeyBcd2Asc(u08 cifra);
rout_ext u08 KeyAsc2Bcd(u08 key);
rout_ext void Bin2Bcd(u08 *pd, u08 value, u08 nChar);
rout_ext u16 Bcd2Bin(u08 *ps, u08 nChar);
rout_ext u08 AsciiNumber(u08 dato);
rout_ext u08 HexAscii(u08 x);
rout_ext void Ui2Asc(u16 n, u08 *p);
rout_ext u08 ShiftRight(u08 *p,u08 len,u08 v);
rout_ext void StrCopy(u08 *ptrDst, u08 *ptrSrc);
rout_ext void StrAppend(u08 *strDst, u08 *strSrc);
rout_ext void CharAppend(u08 *strDst, u08 ch);
rout_ext u16  StrLen(u08 *ptrStr);
rout_ext u08 MemSeekChr(u08 *ptrSrc, u08 chr, u08 *idx, u08 lenMax);
rout_ext u08 StringCopyBeforeEndChar(u08 *ptrDst, u08 *ptrSrc, u08 endChar, u08 maxLen);
rout_ext void Bin2AscStrNchar(u08 *pd, u08 value, u08 nChar);
rout_ext void Bin2Ascii(dword n, u08 *p, u08 len, u08 zeroLead);
rout_ext u08 AbsByteValue(u08 val1, u08 val2);
rout_ext u16 AbsWordValue(u16 val1, u16 val2);
rout_ext dword AbsDwordValue(dword val1, dword val2);
rout_ext void BinDwordToAscii(dword n, u08 *p);
rout_ext void BinWordToAscii(u16 n, u08 *p);
rout_ext void SaveCrc16InRamUinit(u08 *pRam, u16 len);
rout_ext u08  CheckCrc16InRamUinit(u08 *pRam, u16 len);
rout_ext void ValueAscendingOrder(u08 *pArray, u08 len);
rout_ext u32  A2B(u08 *ps, u08 len);
rout_ext u32  GetIntToFloat(float val);
rout_ext void EuroBinToAscii(u32 priceBin, u08 *pPriceAscii);
rout_ext s32 CorrectGain(s32 weightGr);
rout_ext signed long abs_GG(signed long w);
rout_ext void PutWeight(u08 *pd, s32 weightGr, u08 nChars);
rout_ext s16  Curva(s16 X, s16 *X_ITAB, s16 *Y_ITAB, u08 tabSize);
rout_ext void BinToAsciiFloat(u32 bin, u08 *pStr);
rout_ext u08  AsciiFloatToBin(u08 *pAsciiF, u32 *pVal);
rout_ext u08  AsciiChar(u08 dato);
rout_ext u08  CheckDirName(u08 *pDirName);

rout_ext u08  TurnoMaticGetNum(struct _turnoMatic *pTm);
rout_ext u08  TurnoMaticCheck(struct _turnoMatic *pTm, u08 num, u16 wait_100mS);
rout_ext void TurnoMaticIncNum(struct _turnoMatic *pTm);

rout_ext u08 trace[LEN_TRACE_BUFF],traceIdx;
rout_ext u08 Nibble2Ascii(u08  n);
rout_ext u08 Ascii2Nibble(u08  a);
rout_ext u16 Crc16Ble(u08 *p, u16 len, u16 ofst);
rout_ext void AsciiStr2BinArray(u08 *bin, u08 *asc, u16 len);
rout_ext void StrCatLen(char *d, char *s, u16 sLen);


//rout_ext struct _turnoMatic tm;

