#define __TIMER_H

#include <stdlib.h>
#include <stdio.h>
#include "typedef.h"
#include "common.h"
#include "bufcir.h"
#include "rout.h"
#include "main.h"
#include <UART.h>
#include <uart2Drv.h>
#include <timer.h>



////////////////////////////////////////////////////////////////////////////////////////////////
//	LED
const u08 letPatternTable[12][32] = {
	{0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1},
	{0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1,1,1}
};
////////////////////////////////////////////////////////////////////////////////////////////////

//===========================================================================================================
void RunLedBlinkModeInit(void)
//===========================================================================================================
{
	runLed.mode = 255;
	LED_RUN_OFF;
}
//===========================================================================================================
void RunLedBlinkMode(u08 bMode)
//===========================================================================================================
{
	if (runLed.mode != bMode)
	{
		runLed.mode = bMode;		// eseguo la funzione solo se richiesto diverso tipo di lampeggio
		runLed.idx =0;				// SYNC su nuova chiamata  rel 3.5  "061216"
		LED_RUN_OFF;
		runLed.ptr = (const u08 *)&letPatternTable[bMode-1][0];
	}
}



//=====================================================================================
s16 NoTout(u16 msCtr,u16 orgTime,u16 tout)
//=====================================================================================
{
u16 tmp;
	tmp = msCtr - orgTime;
	return(tmp < tout);
}

//=====================================================================================
s16 YesTout(u16 msCtr,u16 orgTime,u16 tout)
//=====================================================================================
{
u16 tmp;
	tmp = msCtr - orgTime;
	return(tmp >= tout);
}

int ctr2mS5 =0;
int ctr10mS =0;
int ctr100mS =0;

u08 toggle;
//char nMsg[100];

enum
{
	SPR_IDLE_SM,
	SPR_SECOND_BLOCK_SM
};

extern void Uart2SendString(char *p);
//================================================================================================
CY_ISR(Timer2mS5)
//================================================================================================
{
    //  --> qui ogni 2,5mS

    Timer1_ClearInterrupt(Timer1__INTR_MASK_CC_MATCH);

    if (comm.delaySend_2mS5)         	--comm.delaySend_2mS5;

	if (comm.toutWaitLF_2mS5)
	{
		if (!--comm.toutWaitLF_2mS5)
		{
			comm.toutRxLF =1;
		}
	}
	if (++ctr2mS5 >= 4)
	{
		// 10mS
		//
		ctr2mS5 =0;

		millisecCtr += 10;

        if (uart2.toutClearRxbuf_10mS)  
            if(!--uart2.toutClearRxbuf_10mS)
                Uart2VarInit();
                
    	if (++ctr10mS >= 10)
        {
		    // 100mS
		    //
    		ctr10mS =0;

//            HandleLink();
            ++toggle;
    		if (bleActive)
	    	{
                if (toggle >= 2)
                {
                    toggle =0;
                    LED_RUN_CPL;
                }
		    }
            else
	    	{
                if (toggle >= 4)
                {
                    toggle =0;
                    LED_RUN_CPL;
                }
		    }
            

           
/*          
            prove per diminuire consumi.... ma non serve a nulla!
            
            ++toggle1;
            if ((toggle1 & 3) == 0)
                CyBle_GapcStopDiscovery();
            if ((toggle1 & 3) == 2)
                CyBle_GapcStartDiscovery(&cyBle_discoveryInfo); //_GG_
*/
        	if (++ctr100mS >= 10)
            {
                // qui ogni 1 Sec
                ctr100mS=0;
            }
            //-----------------------------------------------------------------
        }
	}
}
/* [] END OF FILE */
